/*!
 * KoliBri - The accessible HTML-Standard
 */
"use strict";Object.defineProperty(exports,"__esModule",{value:!0});const index=require("./index-5cf289dd.js"),i18n=require("./i18n-86815e80.js"),ariaCurrentService=require("./ariaCurrentService-53afa476.js"),events=require("./events-221fcb43.js"),componentNames=require("./component-names-b370a3a3.js"),prop_validators=require("./prop.validators-476ef807.js"),href=require("./href-54273ea2.js"),reuse=require("./reuse-daa2baf3.js"),accessKey=require("./access-key-651fa517.js"),ariaExpanded=require("./aria-expanded-42fcd7e7.js"),disabled=require("./disabled-c6505268.js"),hideLabel=require("./hide-label-c2417fe3.js"),icons=require("./icons-30925600.js"),label=require("./label-c3e352c8.js"),tabIndex=require("./tab-index-a2eea6a0.js"),tooltipAlign=require("./tooltip-align-ddef1b9d.js");require("./i18n-bbd0642f.js"),require("./index-1285d2d1.js"),require("./dev.utils-3e595d38.js"),require("./align-e658dfb3.js");const ariaCurrentValuePropTypeOptions=["date","location","page","step","time","true","false"],validateAriaCurrentValue=(e,a)=>{prop_validators.watchValidator(e,"_ariaCurrentValue",(e=>"string"==typeof e&&ariaCurrentValuePropTypeOptions.includes(e)),new Set([`AriaCurrentValue {${ariaCurrentValuePropTypeOptions.join(", ")}`]),a,{defaultValue:"page"})},validateAriaOwns=(e,a)=>{prop_validators.watchString(e,"_ariaOwns",a,{defaultValue:void 0})},validateDownload=(e,a)=>{prop_validators.watchString(e,"_download",a)},validateLinkCallbacks=(e,a)=>{"object"==typeof a&&"function"==typeof(null==a?void 0:a.onClick)&&(e.state=Object.assign(Object.assign({},e.state),{_on:a}))},validateLinkTarget=(e,a)=>{prop_validators.watchString(e,"_target",a)},KolLinkWc=class{constructor(e){index.registerInstance(this,e),this.catchRef=e=>{this.ref=e,reuse.propagateFocus(this.host,this.ref)},this.onClick=e=>{var a,t;!0===this.state._disabled?events.preventDefaultAndStopPropagation(e):"function"==typeof(null===(a=this.state._on)||void 0===a?void 0:a.onClick)&&(e.preventDefault(),e.stopPropagation(),prop_validators.setEventTarget(e,this.ref),null===(t=this.state._on)||void 0===t||t.onClick(e,this.state._href))},this.getRenderValues=()=>{const e="string"==typeof this.state._target&&"_self"!==this.state._target,a={href:"string"==typeof this.state._href&&this.state._href.length>0?this.state._href:"javascript:void(0);",target:"string"==typeof this.state._target&&this.state._target.length>0?this.state._target:void 0,rel:e?"noopener":void 0,download:"string"==typeof this.state._download?this.state._download:void 0};return!0!==this.state._hideLabel||this.state._label||prop_validators.devHint("[KolLink] An aria-label must be set when _hide-label is set."),{isExternal:e,tagAttrs:a}},this._accessKey=void 0,this._ariaCurrentValue=void 0,this._ariaExpanded=void 0,this._ariaOwns=void 0,this._disabled=!1,this._download=void 0,this._hideLabel=!1,this._href=void 0,this._icons=void 0,this._label=void 0,this._on=void 0,this._role=void 0,this._tabIndex=void 0,this._target=void 0,this._tooltipAlign="right",this.state={_ariaCurrentValue:"page",_href:"",_icons:{}}}render(){const{isExternal:e,tagAttrs:a}=this.getRenderValues(),t=reuse.showExpertSlot(this.state._label);return index.h(index.Host,{key:"ba7667ded942c997fc52b057a0f9ce8e2bf79daa",class:"kol-link-wc"},index.h("a",Object.assign({key:"906dd600d85d83dd073e53393e24773f836f5612",ref:this.catchRef},a,{accessKey:this.state._accessKey,"aria-current":this.state._ariaCurrent,"aria-disabled":this.state._disabled?"true":void 0,"aria-expanded":this.state._ariaExpanded?"true":void 0,"aria-owns":this.state._ariaOwns,"aria-label":this.state._hideLabel&&"string"==typeof this.state._label?`${this.state._label}${e?` (${i18n.translate("kol-open-link-in-tab")})`:""}`:void 0,class:{disabled:!0===this.state._disabled,"external-link":e,"hide-label":!0===this.state._hideLabel}},this.state._on,{onClick:this.onClick,onKeyPress:this.onClick,role:this.state._role,tabIndex:this.state._disabled?-1:this.state._tabIndex}),index.h(componentNames.KolSpanWcTag,{key:"0049db400816f9fe77dec4a71b97a6e3c6d4b701",_accessKey:this.state._accessKey,_icons:this.state._icons,_hideLabel:this.state._hideLabel,_label:t?"":this.state._label||this.state._href},index.h("slot",{key:"0f265de4576987908cca965a43bfe261e9ee70bb",name:"expert",slot:"expert"})),e&&index.h(componentNames.KolIconTag,{key:"ea163b0f51cdefb92edbe8382608d87ef7d20b5f",class:"external-link-icon",_label:this.state._hideLabel?"":i18n.translate("kol-open-link-in-tab"),_icons:"codicon codicon-link-external","aria-hidden":this.state._hideLabel})),index.h(componentNames.KolTooltipWcTag,{key:"8eb7db57a9866a93fd275702142a3dd20fd5cb7d","aria-hidden":"true",hidden:t||!this.state._hideLabel,_accessKey:this.state._accessKey,_align:this.state._tooltipAlign,_label:this.state._label||this.state._href}))}validateAccessKey(e){accessKey.validateAccessKey(this,e)}validateAriaCurrentValue(e){validateAriaCurrentValue(this,e)}validateAriaExpanded(e){ariaExpanded.validateAriaExpanded(this,e)}validateAriaOwns(e){validateAriaOwns(this,e)}validateDisabled(e){disabled.validateDisabled(this,e)}validateDownload(e){validateDownload(this,e)}validateHideLabel(e){hideLabel.validateHideLabel(this,e)}validateHref(e){href.validateHref(this,e,{required:!0})}validateIcons(e){icons.validateIcons(this,e)}validateLabel(e){label.validateLabelWithExpertSlot(this,e)}validateOn(e){validateLinkCallbacks(this,e)}validateRole(e){ariaExpanded.validateAlternativeButtonLinkRole(this,e)}validateTabIndex(e){tabIndex.validateTabIndex(this,e)}validateTarget(e){validateLinkTarget(this,e)}validateTooltipAlign(e){tooltipAlign.validateTooltipAlign(this,e)}componentWillLoad(){this.validateAccessKey(this._accessKey),this.validateAriaCurrentValue(this._ariaCurrentValue),this.validateAriaExpanded(this._ariaExpanded),this.validateAriaOwns(this._ariaOwns),this.validateDisabled(this._disabled),this.validateDownload(this._download),this.validateHideLabel(this._hideLabel),this.validateHref(this._href),this.validateIcons(this._icons),this.validateLabel(this._label),this.validateOn(this._on),this.validateRole(this._role),this.validateTabIndex(this._tabIndex),this.validateTarget(this._target),this.validateTooltipAlign(this._tooltipAlign),this.unsubscribeOnLocationChange=ariaCurrentService.onLocationChange((e=>{this.state._ariaCurrent=e===this.state._href?this.state._ariaCurrentValue:void 0}))}disconnectedCallback(){this.unsubscribeOnLocationChange&&this.unsubscribeOnLocationChange()}get host(){return index.getElement(this)}static get watchers(){return{_accessKey:["validateAccessKey"],_ariaCurrentValue:["validateAriaCurrentValue"],_ariaExpanded:["validateAriaExpanded"],_ariaOwns:["validateAriaOwns"],_disabled:["validateDisabled"],_download:["validateDownload"],_hideLabel:["validateHideLabel"],_href:["validateHref"],_icons:["validateIcons"],_label:["validateLabel"],_on:["validateOn"],_role:["validateRole"],_tabIndex:["validateTabIndex"],_target:["validateTarget"],_tooltipAlign:["validateTooltipAlign"]}}};exports.kol_link_wc=KolLinkWc;